function success = Winds_Match_QINF(exp,inpd,qitype,dist,qi)
% collocaton of the cgms study datastes - search for a spatial match
% within less than a specified distance
% make sure to organize set_out by own configuration target box size from smallest to largest

%clear;
indir=sprintf('%s',inpd)
% Set exp: 2,3,4
%exp=3

%qitype=17  % QI with forecast (18) or without (17)
%dist=55    % Distance in km
%qi=50      % QI threshold

if (exp == 1 )
    fall= {'EUM321_csv.csv',  'BRZCPTECfin_121_csv.csv', 'JMA421_csv.csv', 'NOA621_csv.csv' , 'KMA521NI_csv.csv', 'NWC721_csv.csv'};
    tbsize=[16 16 16 17 16];
end

if (exp == 2 )
   %fall= {'EUMETSATDatasetTwo.csv',  'BrazilDatasetTwo.csv', 'JapanDatasetTwoNew.csv', 'NOAADatasetTwo.csv' , 'KoreaDatasetTwo.csv', 'NWCSAFDatasetTwo_O_ET_E.csv'};
   %fall= {'EUM322_csv.csv',  'BRZCPTECfin_122_csv.csv', 'JMA422_csv.csv', 'NOA622_csv.csv' , 'KMA522NI_csv.csv', 'NWC722_csv.csv'};
   fall= {'EUM322_csv.csv',  'BRZCPTECfin_122_csv.csv', 'JMA423_csv.csv', 'NOA622_csv.csv' , 'KMA522NI_csv.csv', 'NWC723_csv.csv'};
   tbsize=[22 24 7 19 16 24];
end

if (exp == 3 )
   %fall= {'EUMETSATDatasetThree.csv', 'BrazilDatasetThree.csv', 'JapanDatasetThreeNew.csv', 'NOAADatasetThree.csv' , 'KoreaDatasetThree.csv', 'NWCSAFDatasetThree_P_ET_E.csv'};
   %fall = {'EUM352_csv.csv',  'BRZCPTECfin_152_csv.csv', 'JMA452_csv.csv', 'NOA652_csv.csv' , 'KMA552NI_csv.csv', 'NWC752_csv.csv'};
   fall = {'EUM352_csv.csv',  'BRZCPTECfin_152_csv.csv', 'JMA453_csv.csv', 'NOA652_csv.csv' , 'KMA552NI_csv.csv', 'NWC753_csv.csv'};
   tbsize=[22 24 7 19 16 24];
end

if (exp == 4 )
   fall= {'EUMETSATDatasetFour.csv', 'BrazilDatasetFour.csv', 'JapanDatasetFourNew.csv', 'NOAADatasetFour.csv' , 'KoreaDatasetFour.csv', 'NWCSAFDatasetFour_O_C_E.csv'};
   tbsize=[24 24 24 24 24 24];
end

%fsym= {'b.'                    ,  'r.'                 , 'g.'                    , 'k.'                 , 'm.'                 , 'y.' };
fsym= {'y.'                    ,  'r.'                 , 'k.'                    , 'b.'                 , 'g.'                 , 'm.' }; 

%set_eum=load([indir,fall{1}]);
%fid = fopen([indirfall{1}]);
%set_eum=textscan(fid, '%d %f %f %d %d %f %f %f %d %f %f %f %f %d %f %d %d %d %d','Delimiter',';', 'HeaderLines', 1);
%fclose(fid);
set_eum=dlmread([indir,fall{1}],';',1,0);
%set_brz=load([indir,fall{2}]);
set_brz=dlmread([indir,fall{2}],';',1,0);
%set_jma=load([indir,fall{3}]);
set_jma=dlmread([indir,fall{3}],';',1,0);
%set_noa=load([indir,fall{4}]);
set_noa=dlmread([indir,fall{4}],';',1,0);
%set_kma=load([indir,fall{5}]);
set_kma=dlmread([indir,fall{5}],';',1,0);
%set_nwc_temp=load([indir,fall{6}]);
set_nwc_temp=dlmread([indir,fall{6}],';',1,0);

set_nwc=sortrows(set_nwc_temp,6);

qivar=[];
qivar=find(set_eum(:,qitype)>=qi);
set_eum=set_eum(qivar,:);
qivar=[];
qivar=find(set_kma(:,qitype)>=qi);
set_kma=set_kma(qivar,:);
qivar=[];
qivar=find(set_brz(:,qitype)>=qi);
set_brz=set_brz(qivar,:);
qivar=[];
qivar=find(set_noa(:,qitype)>=qi);
set_noa=set_noa(qivar,:);
qivar=[];
qivar=find(set_nwc(:,qitype)>=qi);
set_nwc=set_nwc(qivar,:);
qivar=[];
%set_jma(:,qitype)=set_jma(:,qitype)*100.;
set_jma(:,qitype)=set_jma(:,qitype);
qivar=find(set_jma(:,qitype)>=qi);
set_jma=set_jma(qivar,:);


i_out=0;

for i_amv=1:length(set_eum(:,1))
%   disp(i_amv) 
    
    [val1, loc1]=min( deg2km(distance(set_nwc(:,2), set_nwc(:,3), set_eum(i_amv,2), set_eum(i_amv,3)))); % lat/lon metrics

    if val1 < dist
   
            [val2, loc2]=min( deg2km(distance(set_brz(:,2), set_brz(:,3), set_eum(i_amv,2), set_eum(i_amv,3)))); % lat/lon metrics
            
            if val2 < dist
                
                [val3, loc3]=min( deg2km(distance(set_jma(:,2), set_jma(:,3), set_eum(i_amv,2), set_eum(i_amv,3)))); % lat/lon metrics
                
                if val3 < dist
                
                    [val4, loc4]=min( deg2km(distance(set_noa(:,2), set_noa(:,3), set_eum(i_amv,2), set_eum(i_amv,3)))); % lat/lon metrics
                
                    if val4 < dist
                    
                        [val5, loc5]=min( deg2km(distance(set_kma(:,2), set_kma(:,3), set_eum(i_amv,2), set_eum(i_amv,3)))); % lat/lon metrics

                        if val5 < dist        
                    
                    i_out=i_out+1;
                    %set_out_lat(i_out,:) =[ set_eum(loc1,02) set_kma(loc5,02) set_brz(loc2,02)  set_noa(loc4,02) set_nwc(i_amv,02) set_jma(loc3,02) ];
                    set_out_lat(i_out,:) =[ set_jma(loc3,02) set_kma(loc5,02) set_noa(loc4,02) set_eum(i_amv,02) set_brz(loc2,02) set_nwc(loc1,02) ]; 
                    %set_out_lon(i_out,:) =[ set_eum(loc1,03) set_kma(loc5,03) set_brz(loc2,03)  set_noa(loc4,03) set_nwc(i_amv,03) set_jma(loc3,03) ];
                    set_out_lon(i_out,:) =[ set_jma(loc3,03) set_kma(loc5,03) set_noa(loc4,03) set_eum(i_amv,03) set_brz(loc2,03) set_nwc(loc1,03) ];
                    %set_out_spd(i_out,:) =[ set_eum(loc1,06) set_kma(loc5,06) set_brz(loc2,06)  set_noa(loc4,06) set_nwc(i_amv,06) set_jma(loc3,06) ];
                    set_out_spd(i_out,:) =[ set_jma(loc3,06) set_kma(loc5,06) set_noa(loc4,06)  set_eum(i_amv,06) set_brz(loc2,06) set_nwc(loc1,06) ];
                    %set_out_dir(i_out,:) =[ set_eum(loc1,07) set_kma(loc5,07) set_brz(loc2,07)  set_noa(loc4,07) set_nwc(i_amv,07) set_jma(loc3,07) ];
                    set_out_dir(i_out,:) =[ set_jma(loc3,07) set_kma(loc5,07) set_noa(loc4,07)  set_eum(i_amv,07) set_brz(loc2,07) set_nwc(loc1,07) ];
                    %set_out_pres(i_out,:)=[ set_eum(loc1,08) set_kma(loc5,08) set_brz(loc2,08)  set_noa(loc4,08) set_nwc(i_amv,08) set_jma(loc3,08) ];
                    set_out_pres(i_out,:)=[ set_jma(loc3,08) set_kma(loc5,08) set_noa(loc4,08)  set_eum(i_amv,08) set_brz(loc2,08) set_nwc(loc1,08) ];
                    %set_out_ham(i_out,:) =[ set_eum(loc1,16) set_kma(loc5,16) set_brz(loc2,16)  set_noa(loc4,16) set_nwc(i_amv,16) set_jma(loc3,16) ];
                    set_out_ham(i_out,:) =[ set_jma(loc3,16) set_kma(loc5,16) set_noa(loc4,16)  set_eum(i_amv,16) set_brz(loc2,16) set_nwc(loc1,16) ];
                    %set_out_qi(i_out,:)  =[ set_eum(loc1,qitype) set_kma(loc5,qitype) set_brz(loc2,qitype)  set_noa(loc4,qitype) set_nwc(i_amv,qitype) set_jma(loc3,qitype) ];
                    set_out_qi(i_out,:)  =[ set_jma(loc3,qitype) set_kma(loc5,qitype) set_noa(loc4,qitype)  set_eum(i_amv,qitype) set_brz(loc2,qitype) set_nwc(loc1,qitype) ];
                    
                    co_eum(i_out,:) = set_eum(i_amv,:);
                    co_kma(i_out,:) = set_kma(loc5,:);
                    co_brz(i_out,:) = set_brz(loc2,:);
                    co_noa(i_out,:) = set_noa(loc4,:);
                    co_nwc(i_out,:) = set_nwc(loc1,:);
                    co_jma(i_out,:) = set_jma(loc3,:);
                    
                    end;
                end;
            end;
        end
    end;
end;



disp('**************'); 
disp(i_out);

figure;
set(gcf, 'visible', 'off')
x=1:i_out;
subplot(4,1,1);
plot(x,set_out_spd(:,1),fsym{1},x,set_out_spd(:,2),fsym{2},x, set_out_spd(:,3),fsym{3},x,set_out_spd(:,4),fsym{4},x,set_out_spd(:,5),fsym{5},x, set_out_spd(:,6), fsym{6} );
%legend('EUM', 'KMA', 'BRZ', 'NOA', 'NWC', 'JMA');
%lngd=legend({'EUM', 'KMA', 'BRZ', 'NOA', 'NWC', 'JMA'},'Position',[0.85,0.85,0.1,0.1]);
lngd=legend({'JMA', 'KMA', 'NOA', 'EUM', 'BRZ', 'NWC'},'Position',[0.85,0.85,0.1,0.1]);
subplot(4,1,2);
plot(x,set_out_dir(:,1),fsym{1},x,set_out_dir(:,2),fsym{2},x, set_out_dir(:,3),fsym{3},x,set_out_dir(:,4),fsym{4},x,set_out_dir(:,5),fsym{5},x, set_out_dir(:,6),fsym{6} );
subplot(4,1,3);
plot(x,set_out_pres(:,1),fsym{1},x,set_out_pres(:,2),fsym{2},x, set_out_pres(:,3),fsym{3},x,set_out_pres(:,4),fsym{4},x,set_out_pres(:,5),fsym{5},x, set_out_pres(:,6),fsym{6} );
subplot(4,1,4);
plot(x,set_out_qi(:,1),fsym{1},x,set_out_qi(:,2),fsym{2},x, set_out_qi(:,3),fsym{3},x,set_out_qi(:,4),fsym{4},x,set_out_qi(:,5),fsym{5},x,set_out_qi(:,6),fsym{6} );

if (exp == 1)
saveas(gcf,'Exp_21_qinf_all.tif','tif');
   save('Exp_21_conf_eum.txt', 'co_eum', '-ascii');
   save('Exp_21_conf_kma.txt', 'co_kma', '-ascii');
   save('Exp_21_conf_brz.txt', 'co_brz', '-ascii');
   save('Exp_21_conf_noa.txt', 'co_noa', '-ascii');
   save('Exp_21_conf_nwc.txt', 'co_nwc', '-ascii');
   save('Exp_21_conf_jma.txt', 'co_jma', '-ascii');
end    


if ( exp == 2)
   saveas(gcf,'Exp_22_qinf_all.tif','tif');
   save('Exp_22_conf_eum.txt', 'co_eum', '-ascii');
   save('Exp_22_conf_kma.txt', 'co_kma', '-ascii');
   save('Exp_22_conf_brz.txt', 'co_brz', '-ascii');
   save('Exp_22_conf_noa.txt', 'co_noa', '-ascii');
   save('Exp_22_conf_nwc.txt', 'co_nwc', '-ascii');
   save('Exp_22_conf_jma.txt', 'co_jma', '-ascii');
end

if ( exp == 3)
   saveas(gcf,'Exp_52_qinf_all.tif','tif');
   save('Exp_52_conf_eum.txt', 'co_eum', '-ascii');
   save('Exp_52_conf_kma.txt', 'co_kma', '-ascii');
   save('Exp_52_conf_brz.txt', 'co_brz', '-ascii');
   save('Exp_52_conf_noa.txt', 'co_noa', '-ascii');
   save('Exp_52_conf_nwc.txt', 'co_nwc', '-ascii');
   save('Exp_52_conf_jma.txt', 'co_jma', '-ascii');

end

if ( exp == 4)
   saveas(gcf,'Exp_4_qinf_all.tif','tif');
   save('Exp_4_conf_eum.txt', 'co_eum', '-ascii');
   save('Exp_4_conf_kma.txt', 'co_kma', '-ascii');
   save('Exp_4_conf_brz.txt', 'co_brz', '-ascii');
   save('Exp_4_conf_noa.txt', 'co_noa', '-ascii');
   save('Exp_4_conf_nwc.txt', 'co_nwc', '-ascii');
   save('Exp_4_conf_jma.txt', 'co_jma', '-ascii');
end

figure;
set(gcf, 'visible', 'off')
%plot(set_out_pres(:,1),set_out_pres(:,2),'r.',set_out_pres(:,1), set_out_pres(:,3),'g.', set_out_pres(:,1), set_out_pres(:,4),'k.', set_out_pres(:,1), set_out_pres(:,5),'m.', set_out_pres(:,1), set_out_pres(:,6),'y.');
plot(set_out_pres(:,4),set_out_pres(:,1),'y.',set_out_pres(:,4),set_out_pres(:,2),'r.',set_out_pres(:,4), set_out_pres(:,3),'k.',set_out_pres(:,4), set_out_pres(:,5),'g.', set_out_pres(:,4), set_out_pres(:,6),'m.');
%legend('EUM vs KMA','EUM vs BRZ',' EUM vs NOA','EUM vs NWC', 'EUM vs JMA');
%names= {'EUM vs KMA','EUM vs BRZ',' EUM vs NOA','EUM vs NWC', 'EUM vs JMA'};
names= {'EUM vs JMA','EUM vs KMA',' EUM vs NOA','EUM vs BRZ','EUM vs NWC'};
label(1)=names(1);
label(2)=names(2);
label(3)=names(3);
label(4)=names(4);
label(5)=names(5);
legend(gca,label(:),'FontSize',5,'FontWeight','bold','Location','NortheastOutside');
xlabel('Pressure (EUM)');
ylabel('Pressure (Centres)');
title('Scatter Plot of Cloud Height');

if ( exp == 1)
   saveas(gcf,'Exp_21_qinf_pres_scat.tif','tif');
end

if ( exp == 2)
   saveas(gcf,'Exp_22_qinf_pres_scat.tif','tif');
end

if ( exp == 3)
   saveas(gcf,'Exp_52_qinf_pres_scat.tif','tif');
end

if ( exp == 4)
   saveas(gcf,'Exp_4_qinf_pres_scat.tif','tif');
end

figure;
set(gcf, 'visible', 'off')
plot(x,abs(max(set_out_pres')-min(set_out_pres')),'.');
xlabel('AMV Number');
ylabel('Pressure difference');
title('Maximum Pressure difference');

if ( exp == 1)
   saveas(gcf,'Exp_21_qinf_pres_hist.tif','tif');
end

if ( exp == 2)
   saveas(gcf,'Exp_22_qinf_pres_hist.tif','tif');
end

if ( exp == 3)
   saveas(gcf,'Exp_52_qinf_pres_hist.tif','tif');
end

if ( exp == 4)
   saveas(gcf,'Exp_4_qinf_pres_hist.tif','tif');
end

%set_out_names = {'EUMETSAT', 'Korea', 'Brazil', 'NOAA', 'NWCSAF', 'Japan'}
set_out_names = {'Japan', 'Korea', 'NOAA', 'EUMETSAT', 'Brazil', 'NWCSAF'}
%set_out_spd1 = [set_out_spd(:,1), set_out_spd(:,2), set_out_spd(:,3), set_out_spd(:,4), set_out_spd(:,5), set_out_spd(:,6), ((set_out_spd(:,1)+set_out_spd(:,2))/2)];
set_out_spd1 = [set_out_spd(:,1), set_out_spd(:,2), set_out_spd(:,3), set_out_spd(:,4), set_out_spd(:,5), set_out_spd(:,6), ((set_out_spd(:,4)+set_out_spd(:,2))/2)]; 
%fall1 = {'EUMETSAT', 'Korea', 'Brazil', 'NOAA', 'NWCSAF', 'Japan', 'Correct'};
fall1 = {'Japan', 'Korea', 'NOAA', 'EUMETSAT', 'Brazil', 'NWCSAF','Correct'};

outflnm=sprintf('Exp_2%i_statsout.txt',exp);
fid=fopen(outflnm,'w');

for i=1:5
    for n=i:5
        fprintf(fid,'%s "VS" %s \n', set_out_names{i}, set_out_names{n+1});
        [h,p,ci,stats]=ttest(set_out_spd(:,i),set_out_spd(:,n+1));
        fprintf(fid,'  Speed:     h = %d, p = %.2f, ci = %.2f %.2f, Mean: %.2f \n', h, p, ci(1), ci(2), (ci(1)+ci(2))/2);
        [h,p,ci,stats]=ttest(set_out_dir(:,i),set_out_dir(:,n+1));
        fprintf(fid,'  Direction: h = %d, p = %.2f, ci = %.2f %.2f, Mean: %.2f \n', h, p, ci(1), ci(2), (ci(1)+ci(2))/2);
        [h,p,ci,stats]=ttest(set_out_pres(:,i),set_out_pres(:,n+1));
        fprintf(fid,'  Pressure:  h = %d, p = %.2f, ci = %.2f %.2f, Mean: %.2f \n', h, p, ci(1), ci(2), (ci(1)+ci(2))/2);
        [h,p,ci,stats]=ttest(set_out_qi(:,i),set_out_qi(:,n+1));
        fprintf(fid,'  QI:        h = %d, p = %.2f, ci = %.2f %.2f, Mean: %.2f \n\n', h, p, ci(1), ci(2), (ci(1)+ci(2))/2);
    end;
end;
fprintf('\n')
% 
% 
%"Correct" Speed Comparison
for i=1:6
    fprintf(fid,'%s %s \n', 'Speed Correct VS.', fall1{i});
    [h,p,ci,stats]=ttest(set_out_spd1(:,7),set_out_spd1(:,i));
    fprintf(fid,'Speed "Correct": h = %d, p = %.2f, ci = %.2f %.2f, Mean: %.2f \n', h, p, ci(1), ci(2), mean(set_out_spd1(:,7)-set_out_spd1(:,i)));
end;
fclose(fid);
close(figure(1:3))
 success='yes'; 
